kernelopts(assertlevel=2): # be strict on all assertions while testing
kernelopts(opaquemodules=false): # allow testing of internal routines
read "NewSLO.mpl":
if not (NewSLO :: `module`) then
  WARNING("loading NewSLO failed");
  `quit`(3);
end if;

with(NewSLO):


Ite := proc(cond,thn,othw)
    Msum(Weight(piecewise(cond,1,0),thn),Weight(piecewise(cond,0,1),othw))
end proc;

myOr := proc(a,b)
   Ite(a=true,Ret(true),Ret(b))
end proc;

myAnd := proc(a,b)
   Ite(a=true,Ret(b),Ret(false))
end proc;

Bernoulli := proc(p)
    Msum(Weight(p,Ret(true)),Weight(1-p,Ret(false)))
end proc;

Observe := proc(cond,rest)
    Weight(piecewise(cond,1,0),rest)
end proc;

RunNotNormalized := proc(m)
    m := fromLO(improve(toLO(m)));
end proc;

Normalize := proc(m)
    Weight(1/integrate(m,x->1),m)
end proc;

Run := proc(m)
    simplify(fromLO(improve(toLO(Normalize(m)))));
end proc;

clinicalTrial1 :=
	       Bind(Bernoulli(1/2),isEffective,Bind(BetaD(1,1),probControl,Bind(BetaD(1,1),probTreated,Bind(BetaD(1,1),probAll,Bind(Ite(isEffective=true,Bind(Bernoulli(probControl),controlGroup_E0,Observe(controlGroup_E0=true,Bind(Bernoulli(probControl),controlGroup_E1,Observe(controlGroup_E1=true,Bind(Bernoulli(probControl),controlGroup_E2,Observe(controlGroup_E2=true,Bind(Bernoulli(probControl),controlGroup_E3,Observe(controlGroup_E3=true,Bind(Bernoulli(probControl),controlGroup_E4,Observe(controlGroup_E4=true,Bind(Bernoulli(probControl),controlGroup_E5,Observe(controlGroup_E5=true,Bind(Bernoulli(probControl),controlGroup_E6,Observe(controlGroup_E6=true,Bind(Bernoulli(probControl),controlGroup_E7,Observe(controlGroup_E7=true,Bind(Bernoulli(probControl),controlGroup_E8,Observe(controlGroup_E8=true,Bind(Bernoulli(probControl),controlGroup_E9,Observe(controlGroup_E9=true,Bind(Bernoulli(probControl),controlGroup_E10,Observe(controlGroup_E10=true,Bind(Bernoulli(probControl),controlGroup_E11,Observe(controlGroup_E11=true,Bind(Bernoulli(probControl),controlGroup_E12,Observe(controlGroup_E12=true,Bind(Bernoulli(probControl),controlGroup_E13,Observe(controlGroup_E13=true,Bind(Bernoulli(probControl),controlGroup_E14,Observe(controlGroup_E14=true,Bind(Bernoulli(probControl),controlGroup_E15,Observe(controlGroup_E15=true,Bind(Bernoulli(probControl),controlGroup_E16,Observe(controlGroup_E16=true,Bind(Bernoulli(probControl),controlGroup_E17,Observe(controlGroup_E17=true,Bind(Bernoulli(probControl),controlGroup_E18,Observe(controlGroup_E18=true,Bind(Bernoulli(probControl),controlGroup_E19,Observe(controlGroup_E19=true,Bind(Bernoulli(probControl),controlGroup_E20,Observe(controlGroup_E20=true,Bind(Bernoulli(probControl),controlGroup_E21,Observe(controlGroup_E21=true,Bind(Bernoulli(probControl),controlGroup_E22,Observe(controlGroup_E22=true,Bind(Bernoulli(probControl),controlGroup_E23,Observe(controlGroup_E23=true,Bind(Bernoulli(probControl),controlGroup_E24,Observe(controlGroup_E24=true,Bind(Bernoulli(probControl),controlGroup_E25,Observe(controlGroup_E25=true,Bind(Bernoulli(probControl),controlGroup_E26,Observe(controlGroup_E26=true,Bind(Bernoulli(probControl),controlGroup_E27,Observe(controlGroup_E27=true,Bind(Bernoulli(probControl),controlGroup_E28,Observe(controlGroup_E28=true,Bind(Bernoulli(probControl),controlGroup_E29,Observe(controlGroup_E29=true,Bind(Bernoulli(probControl),controlGroup_E30,Observe(controlGroup_E30=true,Bind(Bernoulli(probControl),controlGroup_E31,Observe(controlGroup_E31=true,Bind(Bernoulli(probControl),controlGroup_E32,Observe(controlGroup_E32=true,Bind(Bernoulli(probControl),controlGroup_E33,Observe(controlGroup_E33=true,Bind(Bernoulli(probControl),controlGroup_E34,Observe(controlGroup_E34=true,Bind(Bernoulli(probControl),controlGroup_E35,Observe(controlGroup_E35=true,Bind(Bernoulli(probControl),controlGroup_E36,Observe(controlGroup_E36=true,Bind(Bernoulli(probControl),controlGroup_E37,Observe(controlGroup_E37=true,Bind(Bernoulli(probControl),controlGroup_E38,Observe(controlGroup_E38=true,Bind(Bernoulli(probControl),controlGroup_E39,Observe(controlGroup_E39=true,Bind(Bernoulli(probControl),controlGroup_E40,Observe(controlGroup_E40=true,Bind(Bernoulli(probControl),controlGroup_E41,Observe(controlGroup_E41=true,Bind(Bernoulli(probControl),controlGroup_E42,Observe(controlGroup_E42=true,Bind(Bernoulli(probControl),controlGroup_E43,Observe(controlGroup_E43=true,Bind(Bernoulli(probControl),controlGroup_E44,Observe(controlGroup_E44=true,Bind(Bernoulli(probControl),controlGroup_E45,Observe(controlGroup_E45=true,Bind(Bernoulli(probControl),controlGroup_E46,Observe(controlGroup_E46=true,Bind(Bernoulli(probControl),controlGroup_E47,Observe(controlGroup_E47=true,Bind(Bernoulli(probControl),controlGroup_E48,Observe(controlGroup_E48=true,Bind(Bernoulli(probControl),controlGroup_E49,Observe(controlGroup_E49=true,Bind(Bernoulli(probControl),controlGroup_E50,Observe(controlGroup_E50=true,Bind(Bernoulli(probControl),controlGroup_E51,Observe(controlGroup_E51=true,Bind(Bernoulli(probControl),controlGroup_E52,Observe(controlGroup_E52=true,Bind(Bernoulli(probControl),controlGroup_E53,Observe(controlGroup_E53=true,Bind(Bernoulli(probControl),controlGroup_E54,Observe(controlGroup_E54=true,Bind(Bernoulli(probControl),controlGroup_E55,Observe(controlGroup_E55=true,Bind(Bernoulli(probControl),controlGroup_E56,Observe(controlGroup_E56=true,Bind(Bernoulli(probControl),controlGroup_E57,Observe(controlGroup_E57=true,Bind(Bernoulli(probControl),controlGroup_E58,Observe(controlGroup_E58=true,Bind(Bernoulli(probControl),controlGroup_E59,Observe(controlGroup_E59=true,Bind(Bernoulli(probControl),controlGroup_E60,Observe(controlGroup_E60=true,Bind(Bernoulli(probControl),controlGroup_E61,Observe(controlGroup_E61=true,Bind(Bernoulli(probControl),controlGroup_E62,Observe(controlGroup_E62=true,Bind(Bernoulli(probControl),controlGroup_E63,Observe(controlGroup_E63=true,Bind(Bernoulli(probControl),controlGroup_E64,Observe(controlGroup_E64=true,Bind(Bernoulli(probControl),controlGroup_E65,Observe(controlGroup_E65=true,Bind(Bernoulli(probControl),controlGroup_E66,Observe(controlGroup_E66=true,Bind(Bernoulli(probControl),controlGroup_E67,Observe(controlGroup_E67=true,Bind(Bernoulli(probControl),controlGroup_E68,Observe(controlGroup_E68=true,Bind(Bernoulli(probControl),controlGroup_E69,Observe(controlGroup_E69=true,Bind(Bernoulli(probControl),controlGroup_E70,Observe(controlGroup_E70=true,Bind(Bernoulli(probControl),controlGroup_E71,Observe(controlGroup_E71=true,Bind(Bernoulli(probControl),controlGroup_E72,Observe(controlGroup_E72=true,Bind(Bernoulli(probControl),controlGroup_E73,Observe(controlGroup_E73=true,Bind(Bernoulli(probControl),controlGroup_E74,Observe(controlGroup_E74=true,Bind(Bernoulli(probControl),controlGroup_E75,Observe(controlGroup_E75=true,Bind(Bernoulli(probControl),controlGroup_E76,Observe(controlGroup_E76=true,Bind(Bernoulli(probControl),controlGroup_E77,Observe(controlGroup_E77=true,Bind(Bernoulli(probControl),controlGroup_E78,Observe(controlGroup_E78=true,Bind(Bernoulli(probControl),controlGroup_E79,Observe(controlGroup_E79=true,Bind(Bernoulli(probControl),controlGroup_E80,Observe(controlGroup_E80=true,Bind(Bernoulli(probControl),controlGroup_E81,Observe(controlGroup_E81=true,Bind(Bernoulli(probControl),controlGroup_E82,Observe(controlGroup_E82=true,Bind(Bernoulli(probControl),controlGroup_E83,Observe(controlGroup_E83=true,Bind(Bernoulli(probControl),controlGroup_E84,Observe(controlGroup_E84=true,Bind(Bernoulli(probControl),controlGroup_E85,Observe(controlGroup_E85=true,Bind(Bernoulli(probControl),controlGroup_E86,Observe(controlGroup_E86=true,Bind(Bernoulli(probControl),controlGroup_E87,Observe(controlGroup_E87=true,Bind(Bernoulli(probControl),controlGroup_E88,Observe(controlGroup_E88=true,Bind(Bernoulli(probControl),controlGroup_E89,Observe(controlGroup_E89=true,Bind(Bernoulli(probControl),controlGroup_E90,Observe(controlGroup_E90=true,Bind(Bernoulli(probControl),controlGroup_E91,Observe(controlGroup_E91=true,Bind(Bernoulli(probControl),controlGroup_E92,Observe(controlGroup_E92=true,Bind(Bernoulli(probControl),controlGroup_E93,Observe(controlGroup_E93=true,Bind(Bernoulli(probControl),controlGroup_E94,Observe(controlGroup_E94=true,Bind(Bernoulli(probControl),controlGroup_E95,Observe(controlGroup_E95=true,Bind(Bernoulli(probControl),controlGroup_E96,Observe(controlGroup_E96=true,Bind(Bernoulli(probControl),controlGroup_E97,Observe(controlGroup_E97=true,Bind(Bernoulli(probControl),controlGroup_E98,Observe(controlGroup_E98=true,Bind(Bernoulli(probControl),controlGroup_E99,Observe(controlGroup_E99=true,Bind(Bernoulli(probTreated),treatedGroup_E0,Observe(treatedGroup_E0=true,Bind(Bernoulli(probTreated),treatedGroup_E1,Observe(treatedGroup_E1=true,Bind(Bernoulli(probTreated),treatedGroup_E2,Observe(treatedGroup_E2=true,Bind(Bernoulli(probTreated),treatedGroup_E3,Observe(treatedGroup_E3=true,Bind(Bernoulli(probTreated),treatedGroup_E4,Observe(treatedGroup_E4=true,Bind(Bernoulli(probTreated),treatedGroup_E5,Observe(treatedGroup_E5=true,Bind(Bernoulli(probTreated),treatedGroup_E6,Observe(treatedGroup_E6=true,Bind(Bernoulli(probTreated),treatedGroup_E7,Observe(treatedGroup_E7=true,Bind(Bernoulli(probTreated),treatedGroup_E8,Observe(treatedGroup_E8=true,Bind(Bernoulli(probTreated),treatedGroup_E9,Observe(treatedGroup_E9=true,Bind(Bernoulli(probTreated),treatedGroup_E10,Observe(treatedGroup_E10=true,Bind(Bernoulli(probTreated),treatedGroup_E11,Observe(treatedGroup_E11=true,Bind(Bernoulli(probTreated),treatedGroup_E12,Observe(treatedGroup_E12=true,Bind(Bernoulli(probTreated),treatedGroup_E13,Observe(treatedGroup_E13=true,Bind(Bernoulli(probTreated),treatedGroup_E14,Observe(treatedGroup_E14=true,Bind(Bernoulli(probTreated),treatedGroup_E15,Observe(treatedGroup_E15=true,Bind(Bernoulli(probTreated),treatedGroup_E16,Observe(treatedGroup_E16=true,Bind(Bernoulli(probTreated),treatedGroup_E17,Observe(treatedGroup_E17=true,Bind(Bernoulli(probTreated),treatedGroup_E18,Observe(treatedGroup_E18=true,Bind(Bernoulli(probTreated),treatedGroup_E19,Observe(treatedGroup_E19=true,Bind(Bernoulli(probTreated),treatedGroup_E20,Observe(treatedGroup_E20=true,Bind(Bernoulli(probTreated),treatedGroup_E21,Observe(treatedGroup_E21=true,Bind(Bernoulli(probTreated),treatedGroup_E22,Observe(treatedGroup_E22=true,Bind(Bernoulli(probTreated),treatedGroup_E23,Observe(treatedGroup_E23=true,Bind(Bernoulli(probTreated),treatedGroup_E24,Observe(treatedGroup_E24=true,Bind(Bernoulli(probTreated),treatedGroup_E25,Observe(treatedGroup_E25=true,Bind(Bernoulli(probTreated),treatedGroup_E26,Observe(treatedGroup_E26=true,Bind(Bernoulli(probTreated),treatedGroup_E27,Observe(treatedGroup_E27=true,Bind(Bernoulli(probTreated),treatedGroup_E28,Observe(treatedGroup_E28=true,Bind(Bernoulli(probTreated),treatedGroup_E29,Observe(treatedGroup_E29=true,Bind(Bernoulli(probTreated),treatedGroup_E30,Observe(treatedGroup_E30=true,Bind(Bernoulli(probTreated),treatedGroup_E31,Observe(treatedGroup_E31=true,Bind(Bernoulli(probTreated),treatedGroup_E32,Observe(treatedGroup_E32=true,Bind(Bernoulli(probTreated),treatedGroup_E33,Observe(treatedGroup_E33=true,Bind(Bernoulli(probTreated),treatedGroup_E34,Observe(treatedGroup_E34=true,Bind(Bernoulli(probTreated),treatedGroup_E35,Observe(treatedGroup_E35=true,Bind(Bernoulli(probTreated),treatedGroup_E36,Observe(treatedGroup_E36=true,Bind(Bernoulli(probTreated),treatedGroup_E37,Observe(treatedGroup_E37=true,Bind(Bernoulli(probTreated),treatedGroup_E38,Observe(treatedGroup_E38=true,Bind(Bernoulli(probTreated),treatedGroup_E39,Observe(treatedGroup_E39=true,Bind(Bernoulli(probTreated),treatedGroup_E40,Observe(treatedGroup_E40=true,Bind(Bernoulli(probTreated),treatedGroup_E41,Observe(treatedGroup_E41=true,Bind(Bernoulli(probTreated),treatedGroup_E42,Observe(treatedGroup_E42=true,Bind(Bernoulli(probTreated),treatedGroup_E43,Observe(treatedGroup_E43=true,Bind(Bernoulli(probTreated),treatedGroup_E44,Observe(treatedGroup_E44=true,Bind(Bernoulli(probTreated),treatedGroup_E45,Observe(treatedGroup_E45=true,Bind(Bernoulli(probTreated),treatedGroup_E46,Observe(treatedGroup_E46=true,Bind(Bernoulli(probTreated),treatedGroup_E47,Observe(treatedGroup_E47=true,Bind(Bernoulli(probTreated),treatedGroup_E48,Observe(treatedGroup_E48=true,Bind(Bernoulli(probTreated),treatedGroup_E49,Observe(treatedGroup_E49=true,Bind(Bernoulli(probTreated),treatedGroup_E50,Observe(treatedGroup_E50=true,Bind(Bernoulli(probTreated),treatedGroup_E51,Observe(treatedGroup_E51=true,Bind(Bernoulli(probTreated),treatedGroup_E52,Observe(treatedGroup_E52=true,Bind(Bernoulli(probTreated),treatedGroup_E53,Observe(treatedGroup_E53=true,Bind(Bernoulli(probTreated),treatedGroup_E54,Observe(treatedGroup_E54=true,Bind(Bernoulli(probTreated),treatedGroup_E55,Observe(treatedGroup_E55=true,Bind(Bernoulli(probTreated),treatedGroup_E56,Observe(treatedGroup_E56=true,Bind(Bernoulli(probTreated),treatedGroup_E57,Observe(treatedGroup_E57=true,Bind(Bernoulli(probTreated),treatedGroup_E58,Observe(treatedGroup_E58=true,Bind(Bernoulli(probTreated),treatedGroup_E59,Observe(treatedGroup_E59=true,Bind(Bernoulli(probTreated),treatedGroup_E60,Observe(treatedGroup_E60=true,Bind(Bernoulli(probTreated),treatedGroup_E61,Observe(treatedGroup_E61=true,Bind(Bernoulli(probTreated),treatedGroup_E62,Observe(treatedGroup_E62=true,Bind(Bernoulli(probTreated),treatedGroup_E63,Observe(treatedGroup_E63=true,Bind(Bernoulli(probTreated),treatedGroup_E64,Observe(treatedGroup_E64=true,Bind(Bernoulli(probTreated),treatedGroup_E65,Observe(treatedGroup_E65=true,Bind(Bernoulli(probTreated),treatedGroup_E66,Observe(treatedGroup_E66=true,Bind(Bernoulli(probTreated),treatedGroup_E67,Observe(treatedGroup_E67=true,Bind(Bernoulli(probTreated),treatedGroup_E68,Observe(treatedGroup_E68=true,Bind(Bernoulli(probTreated),treatedGroup_E69,Observe(treatedGroup_E69=true,Bind(Bernoulli(probTreated),treatedGroup_E70,Observe(treatedGroup_E70=true,Bind(Bernoulli(probTreated),treatedGroup_E71,Observe(treatedGroup_E71=true,Bind(Bernoulli(probTreated),treatedGroup_E72,Observe(treatedGroup_E72=true,Bind(Bernoulli(probTreated),treatedGroup_E73,Observe(treatedGroup_E73=true,Bind(Bernoulli(probTreated),treatedGroup_E74,Observe(treatedGroup_E74=true,Bind(Bernoulli(probTreated),treatedGroup_E75,Observe(treatedGroup_E75=true,Bind(Bernoulli(probTreated),treatedGroup_E76,Observe(treatedGroup_E76=true,Bind(Bernoulli(probTreated),treatedGroup_E77,Observe(treatedGroup_E77=true,Bind(Bernoulli(probTreated),treatedGroup_E78,Observe(treatedGroup_E78=true,Bind(Bernoulli(probTreated),treatedGroup_E79,Observe(treatedGroup_E79=true,Bind(Bernoulli(probTreated),treatedGroup_E80,Observe(treatedGroup_E80=true,Bind(Bernoulli(probTreated),treatedGroup_E81,Observe(treatedGroup_E81=true,Bind(Bernoulli(probTreated),treatedGroup_E82,Observe(treatedGroup_E82=true,Bind(Bernoulli(probTreated),treatedGroup_E83,Observe(treatedGroup_E83=true,Bind(Bernoulli(probTreated),treatedGroup_E84,Observe(treatedGroup_E84=true,Bind(Bernoulli(probTreated),treatedGroup_E85,Observe(treatedGroup_E85=true,Bind(Bernoulli(probTreated),treatedGroup_E86,Observe(treatedGroup_E86=true,Bind(Bernoulli(probTreated),treatedGroup_E87,Observe(treatedGroup_E87=true,Bind(Bernoulli(probTreated),treatedGroup_E88,Observe(treatedGroup_E88=true,Bind(Bernoulli(probTreated),treatedGroup_E89,Observe(treatedGroup_E89=true,Bind(Bernoulli(probTreated),treatedGroup_E90,Observe(treatedGroup_E90=true,Bind(Bernoulli(probTreated),treatedGroup_E91,Observe(treatedGroup_E91=true,Bind(Bernoulli(probTreated),treatedGroup_E92,Observe(treatedGroup_E92=true,Bind(Bernoulli(probTreated),treatedGroup_E93,Observe(treatedGroup_E93=true,Bind(Bernoulli(probTreated),treatedGroup_E94,Observe(treatedGroup_E94=true,Bind(Bernoulli(probTreated),treatedGroup_E95,Observe(treatedGroup_E95=true,Bind(Bernoulli(probTreated),treatedGroup_E96,Observe(treatedGroup_E96=true,Bind(Bernoulli(probTreated),treatedGroup_E97,Observe(treatedGroup_E97=true,Bind(Bernoulli(probTreated),treatedGroup_E98,Observe(treatedGroup_E98=true,Bind(Bernoulli(probTreated),treatedGroup_E99,Observe(treatedGroup_E99=true,Ret(Unit))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),Bind(Bernoulli(probAll),controlGroup_I0,Observe(controlGroup_I0=true,Bind(Bernoulli(probAll),controlGroup_I1,Observe(controlGroup_I1=true,Bind(Bernoulli(probAll),controlGroup_I2,Observe(controlGroup_I2=true,Bind(Bernoulli(probAll),controlGroup_I3,Observe(controlGroup_I3=true,Bind(Bernoulli(probAll),controlGroup_I4,Observe(controlGroup_I4=true,Bind(Bernoulli(probAll),controlGroup_I5,Observe(controlGroup_I5=true,Bind(Bernoulli(probAll),controlGroup_I6,Observe(controlGroup_I6=true,Bind(Bernoulli(probAll),controlGroup_I7,Observe(controlGroup_I7=true,Bind(Bernoulli(probAll),controlGroup_I8,Observe(controlGroup_I8=true,Bind(Bernoulli(probAll),controlGroup_I9,Observe(controlGroup_I9=true,Bind(Bernoulli(probAll),controlGroup_I10,Observe(controlGroup_I10=true,Bind(Bernoulli(probAll),controlGroup_I11,Observe(controlGroup_I11=true,Bind(Bernoulli(probAll),controlGroup_I12,Observe(controlGroup_I12=true,Bind(Bernoulli(probAll),controlGroup_I13,Observe(controlGroup_I13=true,Bind(Bernoulli(probAll),controlGroup_I14,Observe(controlGroup_I14=true,Bind(Bernoulli(probAll),controlGroup_I15,Observe(controlGroup_I15=true,Bind(Bernoulli(probAll),controlGroup_I16,Observe(controlGroup_I16=true,Bind(Bernoulli(probAll),controlGroup_I17,Observe(controlGroup_I17=true,Bind(Bernoulli(probAll),controlGroup_I18,Observe(controlGroup_I18=true,Bind(Bernoulli(probAll),controlGroup_I19,Observe(controlGroup_I19=true,Bind(Bernoulli(probAll),controlGroup_I20,Observe(controlGroup_I20=true,Bind(Bernoulli(probAll),controlGroup_I21,Observe(controlGroup_I21=true,Bind(Bernoulli(probAll),controlGroup_I22,Observe(controlGroup_I22=true,Bind(Bernoulli(probAll),controlGroup_I23,Observe(controlGroup_I23=true,Bind(Bernoulli(probAll),controlGroup_I24,Observe(controlGroup_I24=true,Bind(Bernoulli(probAll),controlGroup_I25,Observe(controlGroup_I25=true,Bind(Bernoulli(probAll),controlGroup_I26,Observe(controlGroup_I26=true,Bind(Bernoulli(probAll),controlGroup_I27,Observe(controlGroup_I27=true,Bind(Bernoulli(probAll),controlGroup_I28,Observe(controlGroup_I28=true,Bind(Bernoulli(probAll),controlGroup_I29,Observe(controlGroup_I29=true,Bind(Bernoulli(probAll),controlGroup_I30,Observe(controlGroup_I30=true,Bind(Bernoulli(probAll),controlGroup_I31,Observe(controlGroup_I31=true,Bind(Bernoulli(probAll),controlGroup_I32,Observe(controlGroup_I32=true,Bind(Bernoulli(probAll),controlGroup_I33,Observe(controlGroup_I33=true,Bind(Bernoulli(probAll),controlGroup_I34,Observe(controlGroup_I34=true,Bind(Bernoulli(probAll),controlGroup_I35,Observe(controlGroup_I35=true,Bind(Bernoulli(probAll),controlGroup_I36,Observe(controlGroup_I36=true,Bind(Bernoulli(probAll),controlGroup_I37,Observe(controlGroup_I37=true,Bind(Bernoulli(probAll),controlGroup_I38,Observe(controlGroup_I38=true,Bind(Bernoulli(probAll),controlGroup_I39,Observe(controlGroup_I39=true,Bind(Bernoulli(probAll),controlGroup_I40,Observe(controlGroup_I40=true,Bind(Bernoulli(probAll),controlGroup_I41,Observe(controlGroup_I41=true,Bind(Bernoulli(probAll),controlGroup_I42,Observe(controlGroup_I42=true,Bind(Bernoulli(probAll),controlGroup_I43,Observe(controlGroup_I43=true,Bind(Bernoulli(probAll),controlGroup_I44,Observe(controlGroup_I44=true,Bind(Bernoulli(probAll),controlGroup_I45,Observe(controlGroup_I45=true,Bind(Bernoulli(probAll),controlGroup_I46,Observe(controlGroup_I46=true,Bind(Bernoulli(probAll),controlGroup_I47,Observe(controlGroup_I47=true,Bind(Bernoulli(probAll),controlGroup_I48,Observe(controlGroup_I48=true,Bind(Bernoulli(probAll),controlGroup_I49,Observe(controlGroup_I49=true,Bind(Bernoulli(probAll),controlGroup_I50,Observe(controlGroup_I50=true,Bind(Bernoulli(probAll),controlGroup_I51,Observe(controlGroup_I51=true,Bind(Bernoulli(probAll),controlGroup_I52,Observe(controlGroup_I52=true,Bind(Bernoulli(probAll),controlGroup_I53,Observe(controlGroup_I53=true,Bind(Bernoulli(probAll),controlGroup_I54,Observe(controlGroup_I54=true,Bind(Bernoulli(probAll),controlGroup_I55,Observe(controlGroup_I55=true,Bind(Bernoulli(probAll),controlGroup_I56,Observe(controlGroup_I56=true,Bind(Bernoulli(probAll),controlGroup_I57,Observe(controlGroup_I57=true,Bind(Bernoulli(probAll),controlGroup_I58,Observe(controlGroup_I58=true,Bind(Bernoulli(probAll),controlGroup_I59,Observe(controlGroup_I59=true,Bind(Bernoulli(probAll),controlGroup_I60,Observe(controlGroup_I60=true,Bind(Bernoulli(probAll),controlGroup_I61,Observe(controlGroup_I61=true,Bind(Bernoulli(probAll),controlGroup_I62,Observe(controlGroup_I62=true,Bind(Bernoulli(probAll),controlGroup_I63,Observe(controlGroup_I63=true,Bind(Bernoulli(probAll),controlGroup_I64,Observe(controlGroup_I64=true,Bind(Bernoulli(probAll),controlGroup_I65,Observe(controlGroup_I65=true,Bind(Bernoulli(probAll),controlGroup_I66,Observe(controlGroup_I66=true,Bind(Bernoulli(probAll),controlGroup_I67,Observe(controlGroup_I67=true,Bind(Bernoulli(probAll),controlGroup_I68,Observe(controlGroup_I68=true,Bind(Bernoulli(probAll),controlGroup_I69,Observe(controlGroup_I69=true,Bind(Bernoulli(probAll),controlGroup_I70,Observe(controlGroup_I70=true,Bind(Bernoulli(probAll),controlGroup_I71,Observe(controlGroup_I71=true,Bind(Bernoulli(probAll),controlGroup_I72,Observe(controlGroup_I72=true,Bind(Bernoulli(probAll),controlGroup_I73,Observe(controlGroup_I73=true,Bind(Bernoulli(probAll),controlGroup_I74,Observe(controlGroup_I74=true,Bind(Bernoulli(probAll),controlGroup_I75,Observe(controlGroup_I75=true,Bind(Bernoulli(probAll),controlGroup_I76,Observe(controlGroup_I76=true,Bind(Bernoulli(probAll),controlGroup_I77,Observe(controlGroup_I77=true,Bind(Bernoulli(probAll),controlGroup_I78,Observe(controlGroup_I78=true,Bind(Bernoulli(probAll),controlGroup_I79,Observe(controlGroup_I79=true,Bind(Bernoulli(probAll),controlGroup_I80,Observe(controlGroup_I80=true,Bind(Bernoulli(probAll),controlGroup_I81,Observe(controlGroup_I81=true,Bind(Bernoulli(probAll),controlGroup_I82,Observe(controlGroup_I82=true,Bind(Bernoulli(probAll),controlGroup_I83,Observe(controlGroup_I83=true,Bind(Bernoulli(probAll),controlGroup_I84,Observe(controlGroup_I84=true,Bind(Bernoulli(probAll),controlGroup_I85,Observe(controlGroup_I85=true,Bind(Bernoulli(probAll),controlGroup_I86,Observe(controlGroup_I86=true,Bind(Bernoulli(probAll),controlGroup_I87,Observe(controlGroup_I87=true,Bind(Bernoulli(probAll),controlGroup_I88,Observe(controlGroup_I88=true,Bind(Bernoulli(probAll),controlGroup_I89,Observe(controlGroup_I89=true,Bind(Bernoulli(probAll),controlGroup_I90,Observe(controlGroup_I90=true,Bind(Bernoulli(probAll),controlGroup_I91,Observe(controlGroup_I91=true,Bind(Bernoulli(probAll),controlGroup_I92,Observe(controlGroup_I92=true,Bind(Bernoulli(probAll),controlGroup_I93,Observe(controlGroup_I93=true,Bind(Bernoulli(probAll),controlGroup_I94,Observe(controlGroup_I94=true,Bind(Bernoulli(probAll),controlGroup_I95,Observe(controlGroup_I95=true,Bind(Bernoulli(probAll),controlGroup_I96,Observe(controlGroup_I96=true,Bind(Bernoulli(probAll),controlGroup_I97,Observe(controlGroup_I97=true,Bind(Bernoulli(probAll),controlGroup_I98,Observe(controlGroup_I98=true,Bind(Bernoulli(probAll),controlGroup_I99,Observe(controlGroup_I99=true,Bind(Bernoulli(probAll),treatedGroup_I0,Observe(treatedGroup_I0=true,Bind(Bernoulli(probAll),treatedGroup_I1,Observe(treatedGroup_I1=true,Bind(Bernoulli(probAll),treatedGroup_I2,Observe(treatedGroup_I2=true,Bind(Bernoulli(probAll),treatedGroup_I3,Observe(treatedGroup_I3=true,Bind(Bernoulli(probAll),treatedGroup_I4,Observe(treatedGroup_I4=true,Bind(Bernoulli(probAll),treatedGroup_I5,Observe(treatedGroup_I5=true,Bind(Bernoulli(probAll),treatedGroup_I6,Observe(treatedGroup_I6=true,Bind(Bernoulli(probAll),treatedGroup_I7,Observe(treatedGroup_I7=true,Bind(Bernoulli(probAll),treatedGroup_I8,Observe(treatedGroup_I8=true,Bind(Bernoulli(probAll),treatedGroup_I9,Observe(treatedGroup_I9=true,Bind(Bernoulli(probAll),treatedGroup_I10,Observe(treatedGroup_I10=true,Bind(Bernoulli(probAll),treatedGroup_I11,Observe(treatedGroup_I11=true,Bind(Bernoulli(probAll),treatedGroup_I12,Observe(treatedGroup_I12=true,Bind(Bernoulli(probAll),treatedGroup_I13,Observe(treatedGroup_I13=true,Bind(Bernoulli(probAll),treatedGroup_I14,Observe(treatedGroup_I14=true,Bind(Bernoulli(probAll),treatedGroup_I15,Observe(treatedGroup_I15=true,Bind(Bernoulli(probAll),treatedGroup_I16,Observe(treatedGroup_I16=true,Bind(Bernoulli(probAll),treatedGroup_I17,Observe(treatedGroup_I17=true,Bind(Bernoulli(probAll),treatedGroup_I18,Observe(treatedGroup_I18=true,Bind(Bernoulli(probAll),treatedGroup_I19,Observe(treatedGroup_I19=true,Bind(Bernoulli(probAll),treatedGroup_I20,Observe(treatedGroup_I20=true,Bind(Bernoulli(probAll),treatedGroup_I21,Observe(treatedGroup_I21=true,Bind(Bernoulli(probAll),treatedGroup_I22,Observe(treatedGroup_I22=true,Bind(Bernoulli(probAll),treatedGroup_I23,Observe(treatedGroup_I23=true,Bind(Bernoulli(probAll),treatedGroup_I24,Observe(treatedGroup_I24=true,Bind(Bernoulli(probAll),treatedGroup_I25,Observe(treatedGroup_I25=true,Bind(Bernoulli(probAll),treatedGroup_I26,Observe(treatedGroup_I26=true,Bind(Bernoulli(probAll),treatedGroup_I27,Observe(treatedGroup_I27=true,Bind(Bernoulli(probAll),treatedGroup_I28,Observe(treatedGroup_I28=true,Bind(Bernoulli(probAll),treatedGroup_I29,Observe(treatedGroup_I29=true,Bind(Bernoulli(probAll),treatedGroup_I30,Observe(treatedGroup_I30=true,Bind(Bernoulli(probAll),treatedGroup_I31,Observe(treatedGroup_I31=true,Bind(Bernoulli(probAll),treatedGroup_I32,Observe(treatedGroup_I32=true,Bind(Bernoulli(probAll),treatedGroup_I33,Observe(treatedGroup_I33=true,Bind(Bernoulli(probAll),treatedGroup_I34,Observe(treatedGroup_I34=true,Bind(Bernoulli(probAll),treatedGroup_I35,Observe(treatedGroup_I35=true,Bind(Bernoulli(probAll),treatedGroup_I36,Observe(treatedGroup_I36=true,Bind(Bernoulli(probAll),treatedGroup_I37,Observe(treatedGroup_I37=true,Bind(Bernoulli(probAll),treatedGroup_I38,Observe(treatedGroup_I38=true,Bind(Bernoulli(probAll),treatedGroup_I39,Observe(treatedGroup_I39=true,Bind(Bernoulli(probAll),treatedGroup_I40,Observe(treatedGroup_I40=true,Bind(Bernoulli(probAll),treatedGroup_I41,Observe(treatedGroup_I41=true,Bind(Bernoulli(probAll),treatedGroup_I42,Observe(treatedGroup_I42=true,Bind(Bernoulli(probAll),treatedGroup_I43,Observe(treatedGroup_I43=true,Bind(Bernoulli(probAll),treatedGroup_I44,Observe(treatedGroup_I44=true,Bind(Bernoulli(probAll),treatedGroup_I45,Observe(treatedGroup_I45=true,Bind(Bernoulli(probAll),treatedGroup_I46,Observe(treatedGroup_I46=true,Bind(Bernoulli(probAll),treatedGroup_I47,Observe(treatedGroup_I47=true,Bind(Bernoulli(probAll),treatedGroup_I48,Observe(treatedGroup_I48=true,Bind(Bernoulli(probAll),treatedGroup_I49,Observe(treatedGroup_I49=true,Bind(Bernoulli(probAll),treatedGroup_I50,Observe(treatedGroup_I50=true,Bind(Bernoulli(probAll),treatedGroup_I51,Observe(treatedGroup_I51=true,Bind(Bernoulli(probAll),treatedGroup_I52,Observe(treatedGroup_I52=true,Bind(Bernoulli(probAll),treatedGroup_I53,Observe(treatedGroup_I53=true,Bind(Bernoulli(probAll),treatedGroup_I54,Observe(treatedGroup_I54=true,Bind(Bernoulli(probAll),treatedGroup_I55,Observe(treatedGroup_I55=true,Bind(Bernoulli(probAll),treatedGroup_I56,Observe(treatedGroup_I56=true,Bind(Bernoulli(probAll),treatedGroup_I57,Observe(treatedGroup_I57=true,Bind(Bernoulli(probAll),treatedGroup_I58,Observe(treatedGroup_I58=true,Bind(Bernoulli(probAll),treatedGroup_I59,Observe(treatedGroup_I59=true,Bind(Bernoulli(probAll),treatedGroup_I60,Observe(treatedGroup_I60=true,Bind(Bernoulli(probAll),treatedGroup_I61,Observe(treatedGroup_I61=true,Bind(Bernoulli(probAll),treatedGroup_I62,Observe(treatedGroup_I62=true,Bind(Bernoulli(probAll),treatedGroup_I63,Observe(treatedGroup_I63=true,Bind(Bernoulli(probAll),treatedGroup_I64,Observe(treatedGroup_I64=true,Bind(Bernoulli(probAll),treatedGroup_I65,Observe(treatedGroup_I65=true,Bind(Bernoulli(probAll),treatedGroup_I66,Observe(treatedGroup_I66=true,Bind(Bernoulli(probAll),treatedGroup_I67,Observe(treatedGroup_I67=true,Bind(Bernoulli(probAll),treatedGroup_I68,Observe(treatedGroup_I68=true,Bind(Bernoulli(probAll),treatedGroup_I69,Observe(treatedGroup_I69=true,Bind(Bernoulli(probAll),treatedGroup_I70,Observe(treatedGroup_I70=true,Bind(Bernoulli(probAll),treatedGroup_I71,Observe(treatedGroup_I71=true,Bind(Bernoulli(probAll),treatedGroup_I72,Observe(treatedGroup_I72=true,Bind(Bernoulli(probAll),treatedGroup_I73,Observe(treatedGroup_I73=true,Bind(Bernoulli(probAll),treatedGroup_I74,Observe(treatedGroup_I74=true,Bind(Bernoulli(probAll),treatedGroup_I75,Observe(treatedGroup_I75=true,Bind(Bernoulli(probAll),treatedGroup_I76,Observe(treatedGroup_I76=true,Bind(Bernoulli(probAll),treatedGroup_I77,Observe(treatedGroup_I77=true,Bind(Bernoulli(probAll),treatedGroup_I78,Observe(treatedGroup_I78=true,Bind(Bernoulli(probAll),treatedGroup_I79,Observe(treatedGroup_I79=true,Bind(Bernoulli(probAll),treatedGroup_I80,Observe(treatedGroup_I80=true,Bind(Bernoulli(probAll),treatedGroup_I81,Observe(treatedGroup_I81=true,Bind(Bernoulli(probAll),treatedGroup_I82,Observe(treatedGroup_I82=true,Bind(Bernoulli(probAll),treatedGroup_I83,Observe(treatedGroup_I83=true,Bind(Bernoulli(probAll),treatedGroup_I84,Observe(treatedGroup_I84=true,Bind(Bernoulli(probAll),treatedGroup_I85,Observe(treatedGroup_I85=true,Bind(Bernoulli(probAll),treatedGroup_I86,Observe(treatedGroup_I86=true,Bind(Bernoulli(probAll),treatedGroup_I87,Observe(treatedGroup_I87=true,Bind(Bernoulli(probAll),treatedGroup_I88,Observe(treatedGroup_I88=true,Bind(Bernoulli(probAll),treatedGroup_I89,Observe(treatedGroup_I89=true,Bind(Bernoulli(probAll),treatedGroup_I90,Observe(treatedGroup_I90=true,Bind(Bernoulli(probAll),treatedGroup_I91,Observe(treatedGroup_I91=true,Bind(Bernoulli(probAll),treatedGroup_I92,Observe(treatedGroup_I92=true,Bind(Bernoulli(probAll),treatedGroup_I93,Observe(treatedGroup_I93=true,Bind(Bernoulli(probAll),treatedGroup_I94,Observe(treatedGroup_I94=true,Bind(Bernoulli(probAll),treatedGroup_I95,Observe(treatedGroup_I95=true,Bind(Bernoulli(probAll),treatedGroup_I96,Observe(treatedGroup_I96=true,Bind(Bernoulli(probAll),treatedGroup_I97,Observe(treatedGroup_I97=true,Bind(Bernoulli(probAll),treatedGroup_I98,Observe(treatedGroup_I98=true,Bind(Bernoulli(probAll),treatedGroup_I99,Observe(treatedGroup_I99=true,Ret(Unit)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),unit,Ret(isEffective))))));


RunNotNormalized(clinicalTrial1);